<?php

namespace App\Policies;

use Spatie\Permission\Models\Permission;
// use App\Models\SpatiePermissionModelsPermission;
use App\Models\User;
use Illuminate\Auth\Access\Response;

class PermissionPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        // return false;
        return $user->hasPermissionTo('view permissions');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, Permission $permission): bool
     // public function view(User $user, SpatiePermissionModelsPermission $spatiePermissionModelsPermission): bool
    {
        return $user->hasPermissionTo('view permissions');
        // return false;
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->hasPermissionTo('create permissions');
        // return false;
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, Permission $permission): bool
     // public function update(User $user, SpatiePermissionModelsPermission $spatiePermissionModelsPermission): bool
    {
        return $user->hasPermissionTo('edit permissions');
        // return false;
    }

    /**
     * Determine whether the user can delete the model.
     */
    //public function delete(User $user, Permission $permission): bool
    public function delete(User $user, Permission $permission): bool
     // public function delete(User $user, SpatiePermissionModelsPermission $spatiePermissionModelsPermission): bool
    {
        return $user->hasPermissionTo('delete permissions');
        // return false;
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, Permission $permission): bool
    // public function restore(User $user, SpatiePermissionModelsPermission $spatiePermissionModelsPermission): bool
    {
        return $user->hasPermissionTo('restore permissions');
        // return false;
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, Permission $permission): bool
    // public function forceDelete(User $user, SpatiePermissionModelsPermission $spatiePermissionModelsPermission): bool
    {
        return $user->hasPermissionTo('force-delete permissions');
        // return false;
    }
}
